//+------------------------------------------------------------------+
//|                                            fechamento de gap.mq5 |
//|                                                           Otavio |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Otavio"
#property link      "https://www.mql5.com"
#property version   "1.0"
#include <lib_cisnewbar.mqh>
#include <Trade\Trade.mqh>


//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+

CisNewBar current_chart; // instncia da classe CisNewBar : grfico atual
CTrade  trade;           // instncia da classe CTrade : trade

double            Close_buf[];                                     //Preo de fechamento do ultimo candle do dia anterior;
double            Open_buf[];                                      //Preo de abertura do primeiro candle do dia atual;
double            High_buf[];                                      //Preo mximo do primeiro candle do dia atual;
double            Low_buf[];                                       //Preo mnimo do primeiro candle do dia atual;
string            simbolo;                                          //variable for storing the simbolo
string            op;                                              //Se operao  de compra ou venda;
double            gap;                                             //Falta para fechar o gap;  
string            message;                                         //Menssagem para ser enviada no celular;
ENUM_TIMEFRAMES   periodo;                                          //Tempo do grfico;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   simbolo=Symbol();                                             //salva o ativo do grfico na varivel symbol 
   periodo=PERIOD_M15;                                           //salva o perodo de 15 minutos na varivel periodo
   ArraySetAsSeries(Close_buf,true);                            //define array indexado como uma serie temporal
   ArraySetAsSeries(Open_buf,true);                             //define array indexado como uma serie temporal
   ArraySetAsSeries(High_buf,true);                             //define array indexado como uma serie temporal
   ArraySetAsSeries(Low_buf,true);                              //define array indexado como uma serie temporal

   current_chart.SetSymbol(Symbol());
   current_chart.SetPeriod(Period()); 

      
   return(0);                                                   //return 0, initialization complete
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   ArrayFree(Close_buf);                                        //Limpa da memria a array
   ArrayFree(Open_buf);                                         //Limpa da memria a array
   ArrayFree(High_buf);                                         //Limpa da memria a array
   ArrayFree(Low_buf);                                          //Limpa da memria a array 
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+




void OnTick()
  {
  if(current_chart.isNewBar())
 {  
  datetime horafpc=TimeCurrent();                              // Carrega na varivel horafpc a data e hora do servidor
  string stringhorafpc=TimeToString(horafpc,TIME_SECONDS);     // Carrega a hora, Lowuto e segundo na varivel stringhorafpc
  if(stringhorafpc=="10:15:00")                   // Verifica se so 10:15 e se j foi rodado;
      {
   int err1=0;                                                     //varivel para retornar se os preos foram carregados com sucesso
   int err2=0;                                                     //varivel para retornar se os preos foram carregados com sucesso
   int err3=0;                                                     //varivel para retornar se os preos foram carregados com sucesso
   int err4=0;                                                     //varivel para retornar se os preos foram carregados com sucesso
   err1=CopyClose(simbolo,periodo,1,2,Close_buf);           //Copia os preos do grfico de preos para na array    
   err2=CopyOpen(simbolo,periodo,1,2,Open_buf);             //Copia os preos do grfico de preos para na array    
   err3=CopyHigh(simbolo,periodo,1,2,High_buf);             //Copia os preos do grfico de preos para na array    	
   err4=CopyLow(simbolo,periodo,1,2,Low_buf);               //Copia os preos do grfico de preos para na array    
   if(err1<0 || err2<0 || err3<0 || err4<0)                        //no caso de erro
   {
      Print("Falha ao copiar dados da tabela de preos");          //Print mensagem de erro no log
      return;                                                      //e sai da funo
   }
  // Se abriu com gap de baixa e andou em direo ao fechamento (alta) e no ainda no fechou o gap
  if(Open_buf[0]-Close_buf[1]<0 && Close_buf[0]-Open_buf[0]>0 && High_buf[0]-Close_buf[1]<0) 
    {
    op="Compra";                                                  //Define que operao como compra
    gap=-(High_buf[0]-Close_buf[1]);                              // Quanto ainda falta para fechar o gap (Pontencial de lucro)
    // Envia informaes para celular
    message=("Ativo: "+simbolo+". Operao: "+op+". Falta para fechar o gap: "+DoubleToString(gap,2)+". Start: "+DoubleToString(High_buf[0],2)+". Stop: "+DoubleToString(Low_buf[0],2)+".");  
    // Registra no log
    Print("Ativo: "+simbolo+". Operao: "+op+". Falta para fechar o gap: "+DoubleToString(gap,2)+". Start: "+DoubleToString(High_buf[0],2)+". Stop: "+DoubleToString(Low_buf[0],2)+".");        
    
    }
  // Se abriu com gap de alta e andou em direo ao fechamento (baixa) e no ainda no fechou o gap
  if(Open_buf[0]-Close_buf[1]>0 && Close_buf[0]-Open_buf[0]<0 && Low_buf[0]-Close_buf[1]>0)           
    {
    op="Venda";                                                   //Define que operao como venda
    gap=Low_buf[0]-Close_buf[1];                                  // Quanto ainda falta para fechar o gap (Pontencial de lucro)
    // Envia informaes para celular
    message=("Ativo: "+simbolo+". Operao: "+op+". Falta para fechar o gap: "+DoubleToString(gap,2)+". Start: "+DoubleToString(Low_buf[0],2)+". Stop: "+DoubleToString(High_buf[0],2)+".");  
    // Registra no log
    Print("Ativo: "+simbolo+". Operao: "+op+". Falta para fechar o gap: "+DoubleToString(gap,2)+". Start: "+DoubleToString(Low_buf[0],2)+". Stop: "+DoubleToString(High_buf[0],2)+".");
    }
     }
  } 
 }
 //+------------------------------------------------------------------+